

' VB6/VBA declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter a00
' chapter a00

   Declare Sub nag_implementation_details Lib "CLW3226DE_nag.dll" Alias "a00aac" ( _
   )

   Declare Function nag_licence_query Lib "CLW3226DE_nag.dll" Alias "a00acc" ( _
   ) As long

   Declare Sub nag_implementation_separated_details Lib "CLW3226DE_nag.dll" Alias "a00adc" ( _
    ByVal impl As String, _
    ByVal prec As String, _
    ByVal pcode As String, _
    ByVal mkmaj As String, _
    ByVal mkmin As String, _
    ByVal hdware As String, _
    ByVal opsys As String, _
    ByVal ccomp As String, _
    ByVal fcomp As String, _
    ByVal vend As String, _
    ByRef licval As Nag_Boolean _
   )


' chapter a02
   Declare Function nag_complex Lib "CLW3226DE_nag.dll" Alias "a02bac" ( _
    ByVal x As double, _
    ByVal y As double _
   ) as Complex

   Declare Function nag_complex_real Lib "CLW3226DE_nag.dll" Alias "a02bbc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) As double

   Declare Function nag_complex_imag Lib "CLW3226DE_nag.dll" Alias "a02bcc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) As double

   Declare Function nag_complex_add Lib "CLW3226DE_nag.dll" Alias "a02cac" ( _
    ByVal vRe as Double, ByVal vIm as Double, _
    ByVal wRe as Double, ByVal wIm as Double _
   ) as Complex

   Declare Function nag_complex_subtract Lib "CLW3226DE_nag.dll" Alias "a02cbc" ( _
    ByVal vRe as Double, ByVal vIm as Double, _
    ByVal wRe as Double, ByVal wIm as Double _
   ) as Complex

   Declare Function nag_complex_multiply Lib "CLW3226DE_nag.dll" Alias "a02ccc" ( _
    ByVal vRe as Double, ByVal vIm as Double, _
    ByVal wRe as Double, ByVal wIm as Double _
   ) as Complex

   Declare Function nag_complex_divide Lib "CLW3226DE_nag.dll" Alias "a02cdc" ( _
    ByVal vRe as Double, ByVal vIm as Double, _
    ByVal wRe as Double, ByVal wIm as Double _
   ) as Complex

   Declare Function nag_complex_negate Lib "CLW3226DE_nag.dll" Alias "a02cec" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) as Complex

   Declare Function nag_complex_conjg Lib "CLW3226DE_nag.dll" Alias "a02cfc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) as Complex

   Declare Function nag_complex_equal Lib "CLW3226DE_nag.dll" Alias "a02cgc" ( _
    ByVal vRe as Double, ByVal vIm as Double, _
    ByVal wRe as Double, ByVal wIm as Double _
   ) As long

   Declare Function nag_complex_not_equal Lib "CLW3226DE_nag.dll" Alias "a02chc" ( _
    ByVal vRe as Double, ByVal vIm as Double, _
    ByVal wRe as Double, ByVal wIm as Double _
   ) As long

   Declare Function nag_complex_arg Lib "CLW3226DE_nag.dll" Alias "a02dac" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) As double

   Declare Function nag_complex_abs Lib "CLW3226DE_nag.dll" Alias "a02dbc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) As double

   Declare Function nag_complex_sqrt Lib "CLW3226DE_nag.dll" Alias "a02dcc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) as Complex

   Declare Function nag_complex_i_power Lib "CLW3226DE_nag.dll" Alias "a02ddc" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal i As long _
   ) as Complex

   Declare Function nag_complex_r_power Lib "CLW3226DE_nag.dll" Alias "a02dec" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal x As double _
   ) as Complex

   Declare Function nag_complex_c_power Lib "CLW3226DE_nag.dll" Alias "a02dfc" ( _
    ByVal vRe as Double, ByVal vIm as Double, _
    ByVal wRe as Double, ByVal wIm as Double _
   ) as Complex

   Declare Function nag_complex_log Lib "CLW3226DE_nag.dll" Alias "a02dgc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) as Complex

   Declare Function nag_complex_exp Lib "CLW3226DE_nag.dll" Alias "a02dhc" ( _
    ByVal vRe as Double, ByVal vIm as Double _
   ) as Complex

   Declare Function nag_complex_sin Lib "CLW3226DE_nag.dll" Alias "a02djc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) as Complex

   Declare Function nag_complex_cos Lib "CLW3226DE_nag.dll" Alias "a02dkc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) as Complex

   Declare Function nag_complex_tan Lib "CLW3226DE_nag.dll" Alias "a02dlc" ( _
    ByVal zRe as Double, ByVal zIm as Double _
   ) as Complex

