

' VB6/VBA declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter d01
' skeleton code for callback function
'  Function nag_quad_1d_fin_smooth_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_quad_1d_fin_smooth Lib "CLW3226DE_nag.dll" Alias "d01bdc" ( _
    ByVal f As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef comm As Nag_Comm _
   )

' skeleton code for callback function
'  Function nag_quad_2d_fin_phi1( _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_quad_2d_fin_phi2( _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_quad_2d_fin_f( _
'      ByVal x As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_quad_2d_fin Lib "CLW3226DE_nag.dll" Alias "d01dac" ( _
    ByVal ya As double, _
    ByVal yb As double, _
    ByVal phi1 As Long, _
    ByVal phi2 As Long, _
    ByVal f As Long, _
    ByVal absacc As double, _
    ByRef ans As double, _
    ByRef npts As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_quad_md_sgq_multi_vec_f( _
'      ByVal ni As long, _
'      ByVal ndim As long, _
'      ByVal nx As long, _
'      ByVal xtr As double, _
'      ByVal nntr As long, _
'      ByVal icolzp_iptr As Long, _
'      ByVal irowix_iptr As Long, _
'      ByVal xs_rptr As Long, _
'      ByVal qs_iptr As Long, _
'      ByVal fm_rptr As Long, _
'      ByRef iflag As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_quad_md_sgq_multi_vec Lib "CLW3226DE_nag.dll" Alias "d01esc" ( _
    ByVal ni As long, _
    ByVal ndim As long, _
    ByVal f As Long, _
    ByRef maxdlv As long, _
    ByRef dinest As double, _
    ByRef errest As double, _
    ByRef ivalid As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_quad_md_gauss_fun( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Function nag_quad_md_gauss Lib "CLW3226DE_nag.dll" Alias "d01fbc" ( _
    ByVal ndim As long, _
    ByRef nptvec As long, _
    ByVal lwa As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByVal fun As Long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   ) As double

' skeleton code for callback function
'  Function nag_quad_md_sphere_f( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Sub nag_quad_md_sphere_region( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByVal j As long, _
'      ByRef c As double, _
'      ByRef d As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_quad_md_sphere Lib "CLW3226DE_nag.dll" Alias "d01fdc" ( _
    ByVal ndim As long, _
    ByVal f As Long, _
    ByVal sigma As double, _
    ByVal region As Long, _
    ByVal limit As long, _
    ByVal r0 As double, _
    ByVal u As double, _
    ByRef result As double, _
    ByRef ncalls As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_1d_quad_vals Lib "CLW3226DE_nag.dll" Alias "d01gac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ans As double, _
    ByRef er As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_quad_md_numth_vec_vecfun( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByVal fv_rptr As Long, _
'      ByVal m As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_quad_md_numth_vec_vecreg( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByVal j As long, _
'      ByVal c_rptr As Long, _
'      ByVal d_rptr As Long, _
'      ByVal m As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_quad_md_numth_vec Lib "CLW3226DE_nag.dll" Alias "d01gdc" ( _
    ByVal ndim As long, _
    ByVal vecfun As Long, _
    ByVal vecreg As Long, _
    ByVal npts As long, _
    ByRef vk As double, _
    ByVal nrand As long, _
    ByVal transform As Nag_Boolean, _
    ByRef res As double, _
    ByRef err As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_md_numth_coeff_prime Lib "CLW3226DE_nag.dll" Alias "d01gyc" ( _
    ByVal ndim As long, _
    ByVal npts As long, _
    ByRef vk As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_md_numth_coeff_2prime Lib "CLW3226DE_nag.dll" Alias "d01gzc" ( _
    ByVal ndim As long, _
    ByVal np1 As long, _
    ByVal np2 As long, _
    ByRef vk As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_quad_md_simplex_functn( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_quad_md_simplex Lib "CLW3226DE_nag.dll" Alias "d01pac" ( _
    ByVal ndim As long, _
    ByRef vert As double, _
    ByVal functn As Long, _
    ByRef minord As long, _
    ByVal maxord As long, _
    ByRef finvls As double, _
    ByRef esterr As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_1d_gen_vec_multi_rcomm Lib "CLW3226DE_nag.dll" Alias "d01rac" ( _
    ByRef irevcm As long, ByVal ni As long, ByVal a As double, _
    ByVal b As double, ByRef sid As long, ByRef needi As long, _
    ByRef x As double, ByVal lenx As long, ByRef nx As long, _
    ByRef fm As double, ByVal ldfm As long, ByRef dinest As double, _
    ByRef errest As double, ByRef iopts As long, ByRef opts As double, _
    ByRef icom As long, ByVal licom As long, ByRef com As double, _
    ByVal lcom As long, ByRef fail As NagError _
   )

   Declare Sub nag_quad_1d_gen_vec_multi_dimreq Lib "CLW3226DE_nag.dll" Alias "d01rcc" ( _
    ByVal ni As long, _
    ByRef lenxrq As long, _
    ByRef ldfmrq As long, _
    ByRef sdfmrq As long, _
    ByRef licmin As long, _
    ByRef licmax As long, _
    ByRef lcmin As long, _
    ByRef lcmax As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_quad_1d_fin_gonnet_vec_f( _
'      ByVal x_rptr As Long, _
'      ByVal nx As long, _
'      ByVal fv_rptr As Long, _
'      ByRef iflag As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_quad_1d_fin_gonnet_vec Lib "CLW3226DE_nag.dll" Alias "d01rgc" ( _
    ByVal a As double, _
    ByVal b As double, _
    ByVal f As Long, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByRef dinest As double, _
    ByRef errest As double, _
    ByRef nevals As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_gen_1_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_gen_1 Lib "CLW3226DE_nag.dll" Alias "d01sjc" ( _
    ByVal f As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_osc_1_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_osc_1 Lib "CLW3226DE_nag.dll" Alias "d01skc" ( _
    ByVal f As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_brkpts_1_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_brkpts_1 Lib "CLW3226DE_nag.dll" Alias "d01slc" ( _
    ByVal f As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal nbrkpts As long, _
    ByRef brkpts As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_inf_1_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_inf_1 Lib "CLW3226DE_nag.dll" Alias "d01smc" ( _
    ByVal f As Long, _
    ByVal boundinf As Nag_BoundInterval, _
    ByVal bound As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_wt_trig_1_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_wt_trig_1 Lib "CLW3226DE_nag.dll" Alias "d01snc" ( _
    ByVal g As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal omega As double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_wt_alglog_1_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_wt_alglog_1 Lib "CLW3226DE_nag.dll" Alias "d01spc" ( _
    ByVal g As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal alfa As double, _
    ByVal beta As double, _
    ByVal wt_func As Nag_QuadWeight, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_wt_cauchy_1_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_wt_cauchy_1 Lib "CLW3226DE_nag.dll" Alias "d01sqc" ( _
    ByVal g As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal c As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_quad_inf_wt_trig_1_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_1d_quad_inf_wt_trig_1 Lib "CLW3226DE_nag.dll" Alias "d01ssc" ( _
    ByVal g As Long, _
    ByVal a As double, _
    ByVal omega As double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal maxintervals As long, _
    ByVal max_num_subint As long, _
    ByVal epsabs As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qpsub As Nag_QuadSubProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_1d_withdraw_quad_gauss_1_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Function nag_1d_withdraw_quad_gauss_1 Lib "CLW3226DE_nag.dll" Alias "d01tac" ( _
    ByVal quadrule As Nag_GaussFormulae, _
    ByVal f As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal npts As long, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_quad_1d_gauss_wset Lib "CLW3226DE_nag.dll" Alias "d01tbc" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_1d_gauss_wgen Lib "CLW3226DE_nag.dll" Alias "d01tcc" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal c As double, _
    ByVal d As double, _
    ByVal n As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_1d_gauss_wrec Lib "CLW3226DE_nag.dll" Alias "d01tdc" ( _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByVal muzero As double, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_1d_gauss_recm Lib "CLW3226DE_nag.dll" Alias "d01tec" ( _
    ByVal n As long, _
    ByRef mu As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_quad_1d_gauss_vec_f( _
'      ByVal x_rptr As Long, _
'      ByVal nx As long, _
'      ByVal fv_rptr As Long, _
'      ByRef iflag As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_quad_1d_gauss_vec Lib "CLW3226DE_nag.dll" Alias "d01uac" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByVal f As Long, _
    ByRef dinest As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_quad_1d_inf_exp_wt_fun( _
'      ByVal x_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByVal n As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef istop As long _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_quad_1d_inf_exp_wt Lib "CLW3226DE_nag.dll" Alias "d01ubc" ( _
    ByVal fun As Long, _
    ByVal n As long, _
    ByRef ans As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_multid_quad_adapt_1_f( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_multid_quad_adapt_1 Lib "CLW3226DE_nag.dll" Alias "d01wcc" ( _
    ByVal ndim As long, _
    ByVal f As Long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef minpts As long, _
    ByVal maxpts As long, _
    ByVal eps As double, _
    ByRef finval As double, _
    ByRef acc As double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_multid_quad_monte_carlo_1_f( _
'      ByVal ndim As long, _
'      ByVal x_rptr As Long, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_multid_quad_monte_carlo_1 Lib "CLW3226DE_nag.dll" Alias "d01xbc" ( _
    ByVal ndim As long, _
    ByVal f As Long, _
    ByVal method As Nag_MCMethod, _
    ByVal cont As Nag_Start, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef mincls As long, _
    ByVal maxcls As long, _
    ByVal eps As double, _
    ByRef finest As double, _
    ByRef acc As double, _
    ByRef comm_arrptr As Long, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_opt_set Lib "CLW3226DE_nag.dll" Alias "d01zkc" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quad_opt_get Lib "CLW3226DE_nag.dll" Alias "d01zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


' chapter d02
' skeleton code for callback function
'  Sub nag_ode_ivp_adams_gen_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_ivp_adams_gen_output( _
'      ByVal neq As long, _
'      ByRef xsol As double, _
'      ByVal y_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function nag_ode_ivp_adams_gen_g( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_ode_ivp_adams_gen Lib "CLW3226DE_nag.dll" Alias "d02cjc" ( _
    ByVal neq As long, _
    ByVal fcn As Long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal xend As double, _
    ByVal tol As double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As Long, _
    ByVal g As Long, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_ivp_bdf_gen_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_ivp_bdf_gen_pederv( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal pw_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_ivp_bdf_gen_output( _
'      ByVal neq As long, _
'      ByRef xsol As double, _
'      ByVal y_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function nag_ode_ivp_bdf_gen_g( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_ode_ivp_bdf_gen Lib "CLW3226DE_nag.dll" Alias "d02ejc" ( _
    ByVal neq As long, _
    ByVal fcn As Long, _
    ByVal pederv As Long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal xend As double, _
    ByVal tol As double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As Long, _
    ByVal g As Long, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_nonlin_fixedbc_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_ode_bvp_fd_nonlin_fixedbc Lib "CLW3226DE_nag.dll" Alias "d02gac" ( _
    ByVal neq As long, _
    ByVal fcn As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef u As double, _
    ByRef v As long, _
    ByVal mnp As long, _
    ByRef np As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal tol As double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_lin_gen_fcnf( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_lin_gen_fcng( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal g_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_ode_bvp_fd_lin_gen Lib "CLW3226DE_nag.dll" Alias "d02gbc" ( _
    ByVal neq As long, _
    ByVal fcnf As Long, _
    ByVal fcng As Long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef gam As double, _
    ByVal mnp As long, _
    ByRef np As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal tol As double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

   Declare Sub nag_dae_ivp_dassl_cont Lib "CLW3226DE_nag.dll" Alias "d02mcc" ( _
    ByRef icom As long _
   )

   Declare Sub nag_dae_ivp_dassl_setup Lib "CLW3226DE_nag.dll" Alias "d02mwc" ( _
    ByVal neq As long, _
    ByVal maxord As long, _
    ByVal jceval As Nag_EvaluateJacobian, _
    ByVal hmax As double, _
    ByVal h0 As double, _
    ByVal vector_tol As Nag_Boolean, _
    ByRef icom As long, _
    ByVal licom As long, _
    ByRef com As double, _
    ByVal lcom As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_dae_ivp_dassl_gen_res( _
'      ByVal neq As long, _
'      ByVal t As double, _
'      ByVal y_rptr As Long, _
'      ByVal ydot_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_dae_ivp_dassl_gen_jac( _
'      ByVal neq As long, _
'      ByVal t As double, _
'      ByVal y_rptr As Long, _
'      ByVal ydot_rptr As Long, _
'      ByVal pd_rptr As Long, _
'      ByVal cj As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_dae_ivp_dassl_gen Lib "CLW3226DE_nag.dll" Alias "d02nec" ( _
    ByVal neq As long, _
    ByRef t As double, _
    ByVal tout As double, _
    ByRef y As double, _
    ByRef ydot As double, _
    ByRef rtol As double, _
    ByRef atol As double, _
    ByRef itask As long, _
    ByVal res As Long, _
    ByVal jac As Long, _
    ByRef icom As long, _
    ByRef com As double, _
    ByVal lcom As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_dae_ivp_dassl_linalg Lib "CLW3226DE_nag.dll" Alias "d02npc" ( _
    ByVal neq As long, _
    ByVal ml As long, _
    ByVal mu As long, _
    ByRef icom As long, _
    ByVal licom As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_ivp_rkts_range_f( _
'      ByVal t As double, _
'      ByVal n As long, _
'      ByVal y_rptr As Long, _
'      ByVal yp_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_ode_ivp_rkts_range Lib "CLW3226DE_nag.dll" Alias "d02pec" ( _
    ByVal f As Long, _
    ByVal n As long, _
    ByVal twant As double, _
    ByRef tgot As double, _
    ByRef ygot As double, _
    ByRef ypgot As double, _
    ByRef ymax As double, _
    ByRef comm As Nag_Comm, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_ivp_rkts_onestep_f( _
'      ByVal t As double, _
'      ByVal n As long, _
'      ByVal y_rptr As Long, _
'      ByVal yp_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_ode_ivp_rkts_onestep Lib "CLW3226DE_nag.dll" Alias "d02pfc" ( _
    ByVal f As Long, _
    ByVal n As long, _
    ByRef tnow As double, _
    ByRef ynow As double, _
    ByRef ypnow As double, _
    ByRef comm As Nag_Comm, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_rk_step_revcomm Lib "CLW3226DE_nag.dll" Alias "d02pgc" ( _
    ByRef irevcm As long, _
    ByVal n As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_rk_interp_setup Lib "CLW3226DE_nag.dll" Alias "d02phc" ( _
    ByRef irevcm As long, _
    ByVal n As long, _
    ByVal nwant As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef wcomm As double, _
    ByVal lwcomm As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_rk_interp_eval Lib "CLW3226DE_nag.dll" Alias "d02pjc" ( _
    ByVal icheck As Nag_Boolean, _
    ByVal n As long, _
    ByVal nwant As long, _
    ByVal t As double, _
    ByVal ideriv As long, _
    ByRef sol As double, _
    ByRef wcomm As double, _
    ByVal lwcomm As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_rkts_setup Lib "CLW3226DE_nag.dll" Alias "d02pqc" ( _
    ByVal n As long, _
    ByVal tstart As double, _
    ByVal tend As double, _
    ByRef yinit As double, _
    ByVal tol As double, _
    ByRef thresh As double, _
    ByVal method As Nag_RK_method, _
    ByVal errass As Nag_ErrorAssess, _
    ByVal hstart As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_rkts_reset_tend Lib "CLW3226DE_nag.dll" Alias "d02prc" ( _
    ByVal tendnu As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_ivp_rkts_interp_f( _
'      ByVal t As double, _
'      ByVal n As long, _
'      ByVal y_rptr As Long, _
'      ByVal yp_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_ode_ivp_rkts_interp Lib "CLW3226DE_nag.dll" Alias "d02psc" ( _
    ByVal n As long, _
    ByVal twant As double, _
    ByVal reqest As Nag_SolDeriv, _
    ByVal nwant As long, _
    ByRef ywant As double, _
    ByRef ypwant As double, _
    ByVal f As Long, _
    ByRef wcomm As double, _
    ByVal lwcomm As long, _
    ByRef comm As Nag_Comm, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_rkts_diag Lib "CLW3226DE_nag.dll" Alias "d02ptc" ( _
    ByRef fevals As long, _
    ByRef stepcost As long, _
    ByRef waste As double, _
    ByRef stepsok As long, _
    ByRef hnext As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_rkts_errass Lib "CLW3226DE_nag.dll" Alias "d02puc" ( _
    ByVal n As long, _
    ByRef rmserr As double, _
    ByRef errmax As double, _
    ByRef terrmx As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_ivp_adams_roots_fcn( _
'      ByVal neqf As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function nag_ode_ivp_adams_roots_g( _
'      ByVal neqf As long, _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal yp_rptr As Long, _
'      ByVal k As long, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_ode_ivp_adams_roots Lib "CLW3226DE_nag.dll" Alias "d02qfc" ( _
    ByVal neqf As long, _
    ByVal fcn As Long, _
    ByRef t As double, _
    ByRef y As double, _
    ByVal tout As double, _
    ByVal g As Long, _
    ByRef comm As Nag_User, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_adams_setup Lib "CLW3226DE_nag.dll" Alias "d02qwc" ( _
    ByRef state As Nag_Start, _
    ByVal neqf As long, _
    ByVal vectol As Nag_Boolean, _
    ByRef atol As double, _
    ByRef rtol As double, _
    ByVal one_step As Nag_Boolean, _
    ByVal crit As Nag_Boolean, _
    ByVal tcrit As double, _
    ByVal hmax As double, _
    ByVal max_step As long, _
    ByVal neqg As long, _
    ByRef alter_g As Nag_Boolean, _
    ByVal sophist As Nag_Boolean, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_ivp_adams_free Lib "CLW3226DE_nag.dll" Alias "d02qyc" ( _
    ByRef opt As Nag_ODE_Adams _
   )

   Declare Sub nag_ode_ivp_adams_interp Lib "CLW3226DE_nag.dll" Alias "d02qzc" ( _
    ByVal neqf As long, _
    ByVal twant As double, _
    ByVal nwant As long, _
    ByRef ywant As double, _
    ByRef ypwant As double, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_nonlin_gen_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal eps As double, _
'      ByVal y_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_nonlin_gen_g( _
'      ByVal neq As long, _
'      ByVal eps As double, _
'      ByVal ya_rptr As Long, _
'      ByVal yb_rptr As Long, _
'      ByVal bc_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_nonlin_gen_jacobf( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal eps As double, _
'      ByVal y_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_nonlin_gen_jacobg( _
'      ByVal neq As long, _
'      ByVal eps As double, _
'      ByVal ya_rptr As Long, _
'      ByVal yb_rptr As Long, _
'      ByVal aj_rptr As Long, _
'      ByVal bj_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_nonlin_gen_jaceps( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal eps As double, _
'      ByVal y_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_fd_nonlin_gen_jacgep( _
'      ByVal neq As long, _
'      ByVal eps As double, _
'      ByVal ya_rptr As Long, _
'      ByVal yb_rptr As Long, _
'      ByVal bcep_rptr As Long, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_ode_bvp_fd_nonlin_gen Lib "CLW3226DE_nag.dll" Alias "d02rac" ( _
    ByVal neq As long, _
    ByRef deleps As double, _
    ByVal fcn As Long, _
    ByVal numbeg As long, _
    ByVal nummix As long, _
    ByVal g As Long, _
    ByVal init As Nag_MeshSet, _
    ByVal mnp As long, _
    ByRef np As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal tol As double, _
    ByRef abt As double, _
    ByVal jacobf As Long, _
    ByVal jacobg As Long, _
    ByVal jaceps As Long, _
    ByVal jacgep As Long, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_ode_bvp_coll_nlin_solve_ffun( _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal neq As long, _
'      ByVal m_iptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_coll_nlin_solve_fjac( _
'      ByVal x As double, _
'      ByVal y_rptr As Long, _
'      ByVal neq As long, _
'      ByVal m_iptr As Long, _
'      ByVal dfdy_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_coll_nlin_solve_gafun( _
'      ByVal ya_rptr As Long, _
'      ByVal neq As long, _
'      ByVal m_iptr As Long, _
'      ByVal nlbc As long, _
'      ByVal ga_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_coll_nlin_solve_gbfun( _
'      ByVal yb_rptr As Long, _
'      ByVal neq As long, _
'      ByVal m_iptr As Long, _
'      ByVal nrbc As long, _
'      ByVal gb_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_coll_nlin_solve_gajac( _
'      ByVal ya_rptr As Long, _
'      ByVal neq As long, _
'      ByVal m_iptr As Long, _
'      ByVal nlbc As long, _
'      ByVal dgady_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_coll_nlin_solve_gbjac( _
'      ByVal yb_rptr As Long, _
'      ByVal neq As long, _
'      ByVal m_iptr As Long, _
'      ByVal nrbc As long, _
'      ByVal dgbdy_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_ode_bvp_coll_nlin_solve_guess( _
'      ByVal x As double, _
'      ByVal neq As long, _
'      ByVal m_iptr As Long, _
'      ByVal y_rptr As Long, _
'      ByVal dym_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_ode_bvp_coll_nlin_solve Lib "CLW3226DE_nag.dll" Alias "d02tlc" ( _
    ByVal ffun As Long, _
    ByVal fjac As Long, _
    ByVal gafun As Long, _
    ByVal gbfun As Long, _
    ByVal gajac As Long, _
    ByVal gbjac As Long, _
    ByVal guess As Long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_coll_nlin_setup Lib "CLW3226DE_nag.dll" Alias "d02tvc" ( _
    ByVal neq As long, _
    ByRef m As long, _
    ByVal nlbc As long, _
    ByVal nrbc As long, _
    ByVal ncol As long, _
    ByRef tols As double, _
    ByVal mxmesh As long, _
    ByVal nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef rcomm As double, _
    ByVal lrcomm As long, _
    ByRef icomm As long, _
    ByVal licomm As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_coll_nlin_contin Lib "CLW3226DE_nag.dll" Alias "d02txc" ( _
    ByVal mxmesh As long, _
    ByVal nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_coll_nlin_interp Lib "CLW3226DE_nag.dll" Alias "d02tyc" ( _
    ByVal x As double, _
    ByRef y As double, _
    ByVal neq As long, _
    ByVal mmax As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_coll_nlin_diag Lib "CLW3226DE_nag.dll" Alias "d02tzc" ( _
    ByVal mxmesh As long, _
    ByRef nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef ermx As double, _
    ByRef iermx As long, _
    ByRef ijermx As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_coeffs Lib "CLW3226DE_nag.dll" Alias "d02uac" ( _
    ByVal n As long, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_cgl_vals Lib "CLW3226DE_nag.dll" Alias "d02ubc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal q As long, _
    ByRef c As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_cgl_grid Lib "CLW3226DE_nag.dll" Alias "d02ucc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_cgl_deriv Lib "CLW3226DE_nag.dll" Alias "d02udc" ( _
    ByVal n As long, _
    ByRef f As double, _
    ByRef fd As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_solve Lib "CLW3226DE_nag.dll" Alias "d02uec" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal m As long, _
    ByRef c As double, _
    ByRef bmat As double, _
    ByRef y As double, _
    ByRef bvec As double, _
    ByRef f As double, _
    ByRef uc As double, _
    ByRef resid As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_grid_vals Lib "CLW3226DE_nag.dll" Alias "d02uwc" ( _
    ByVal n As long, _
    ByVal nip As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef xip As double, _
    ByRef fip As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_quad_weights Lib "CLW3226DE_nag.dll" Alias "d02uyc" ( _
    ByVal n As long, _
    ByRef w As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ode_bvp_ps_lin_cheb_eval Lib "CLW3226DE_nag.dll" Alias "d02uzc" ( _
    ByVal k As long, _
    ByVal x As double, _
    ByRef t As double, _
    ByRef fail As NagError _
   )


' chapter d03
   Declare Sub nag_pde_bs_1d Lib "CLW3226DE_nag.dll" Alias "d03ncc" ( _
    ByVal kopt As Nag_OptionType, ByVal x As double, ByVal mesh As Nag_MeshType, _
    ByVal ns As long, ByRef s As double, ByVal nt As long, _
    ByRef t As double, ByRef tdpar As Nag_Boolean, ByRef r As double, _
    ByRef q As double, ByRef sigma As double, ByVal alpha As double, _
    ByVal ntkeep As long, ByRef f As double, ByRef theta As double, _
    ByRef delta As double, ByRef gamma As double, ByRef lambda As double, _
    ByRef rho As double, ByRef fail As NagError _
   )

   Declare Sub nag_pde_bs_1d_analytic Lib "CLW3226DE_nag.dll" Alias "d03ndc" ( _
    ByVal kopt As Nag_OptionType, _
    ByVal x As double, _
    ByVal s As double, _
    ByVal t As double, _
    ByVal tmat As double, _
    ByRef tdpar As Nag_Boolean, _
    ByRef r As double, _
    ByRef q As double, _
    ByRef sigma As double, _
    ByRef f As double, _
    ByRef theta As double, _
    ByRef delta As double, _
    ByRef gamma As double, _
    ByRef lambda As double, _
    ByRef rho As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pde_bs_1d_means Lib "CLW3226DE_nag.dll" Alias "d03nec" ( _
    ByVal t0 As double, _
    ByVal tmat As double, _
    ByVal ntd As long, _
    ByRef td As double, _
    ByRef phid As double, _
    ByRef phiav As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal q_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As Long, _
'      ByVal gamma_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_fd Lib "CLW3226DE_nag.dll" Alias "d03pcc" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As Long, _
    ByVal bndary As Long, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal acc As double, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_coll_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x_rptr As Long, _
'      ByVal nptl As long, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal q_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_coll_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As Long, _
'      ByVal gamma_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_coll_uinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_coll Lib "CLW3226DE_nag.dll" Alias "d03pdc" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As Long, _
    ByVal bndary As Long, _
    ByRef u As double, ByVal nbkpts As long, ByRef xbkpts As double, _
    ByVal npoly As long, ByVal npts As long, ByRef x As double, _
    ByVal uinit As Long, _
    ByVal acc As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ut_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal res_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ibnd As long, _
'      ByVal nobc As long, _
'      ByVal u_rptr As Long, _
'      ByVal ut_rptr As Long, _
'      ByVal res_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_keller Lib "CLW3226DE_nag.dll" Alias "d03pec" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As Long, _
    ByVal bndary As Long, ByRef u As double, _
    ByVal npts As long, ByRef x As double, ByVal nleft As long, _
    ByVal acc As double, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal c_rptr As Long, _
'      ByVal d_rptr As Long, _
'      ByVal s_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_numflx( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal uleft_rptr As Long, _
'      ByVal uright_rptr As Long, _
'      ByVal flux_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef saved As Nag_D03_Save _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_bndary( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal t As double, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal g_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_cd Lib "CLW3226DE_nag.dll" Alias "d03pfc" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As Long, _
    ByVal numflx As Long, _
    ByVal bndary As Long, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByRef acc As double, ByVal tsmax As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal q_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As Long, _
'      ByVal gamma_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As Long, _
'      ByVal ucp_rptr As Long, _
'      ByVal ucpx_rptr As Long, _
'      ByVal rcp_rptr As Long, _
'      ByVal ucpt_rptr As Long, _
'      ByVal ucptx_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_fd_ode Lib "CLW3226DE_nag.dll" Alias "d03phc" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As Long, _
    ByVal bndary As Long, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal ncode As long, ByVal odedef As Long, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByVal itol As long, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_coll_ode_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x_rptr As Long, _
'      ByVal nptl As long, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal q_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_coll_ode_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As Long, _
'      ByVal gamma_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_coll_ode_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As Long, _
'      ByVal ucp_rptr As Long, _
'      ByVal ucpx_rptr As Long, _
'      ByVal rcp_rptr As Long, _
'      ByVal ucpt_rptr As Long, _
'      ByVal ucptx_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_coll_ode_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_coll_ode Lib "CLW3226DE_nag.dll" Alias "d03pjc" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As Long, _
    ByVal bndary As Long, _
    ByRef u As double, ByVal nbkpts As long, ByRef xbkpts As double, _
    ByVal npoly As long, ByVal npts As long, ByRef x As double, _
    ByVal ncode As long, ByVal odedef As Long, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByVal uvinit As Long, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByRef rsave As double, ByVal lrsave As long, ByRef isave As long, _
    ByVal lisave As long, ByVal itask As long, ByVal itrace As long, _
    ByVal outfile As String, ByRef ind As long, _
    ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ut_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal res_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ibnd As long, _
'      ByVal nobc As long, _
'      ByVal u_rptr As Long, _
'      ByVal ut_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal res_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As Long, _
'      ByVal ucp_rptr As Long, _
'      ByVal ucpx_rptr As Long, _
'      ByVal ucpt_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_keller_ode Lib "CLW3226DE_nag.dll" Alias "d03pkc" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As Long, _
    ByVal bndary As Long, ByRef u As double, _
    ByVal npts As long, ByRef x As double, ByVal nleft As long, _
    ByVal ncode As long, ByVal odedef As Long, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByVal itol As long, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal c_rptr As Long, _
'      ByVal d_rptr As Long, _
'      ByVal s_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_numflx( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal uleft_rptr As Long, _
'      ByVal uright_rptr As Long, _
'      ByVal flux_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef saved As Nag_D03_Save _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_bndary( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal t As double, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal g_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As Long, _
'      ByVal ucp_rptr As Long, _
'      ByVal ucpx_rptr As Long, _
'      ByVal ucpt_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_cd_ode Lib "CLW3226DE_nag.dll" Alias "d03plc" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As Long, _
    ByVal numflx As Long, _
    ByVal bndary As Long, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal ncode As long, ByVal odedef As Long, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByVal itol As long, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_remesh_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal q_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_remesh_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As Long, _
'      ByVal gamma_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_remesh_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal nxi As long, _
'      ByVal x_rptr As Long, _
'      ByVal xi_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_remesh_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As Long, _
'      ByVal ucp_rptr As Long, _
'      ByVal ucpx_rptr As Long, _
'      ByVal rcp_rptr As Long, _
'      ByVal ucpt_rptr As Long, _
'      ByVal ucptx_rptr As Long, _
'      ByVal f_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_fd_ode_remesh_monitf( _
'      ByVal t As double, _
'      ByVal npts As long, _
'      ByVal npde As long, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByVal fmon_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_fd_ode_remesh Lib "CLW3226DE_nag.dll" Alias "d03ppc" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As Long, _
    ByVal bndary As Long, _
    ByVal uvinit As Long, ByRef u As double, ByVal npts As long, _
    ByRef x As double, ByVal ncode As long, ByVal odedef As Long, _
    ByVal nxi As long, ByRef xi As double, ByVal neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByVal remesh As Nag_Boolean, ByVal nxfix As long, ByRef xfix As double, _
    ByVal nrmesh As long, ByVal dxmesh As double, ByVal trmesh As double, _
    ByVal ipminf As long, ByVal xratio As double, ByVal con As double, _
    ByVal monitf As Long, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_remesh_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal udot_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal res_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_remesh_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ibnd As long, _
'      ByVal nobc As long, _
'      ByVal u_rptr As Long, _
'      ByVal udot_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal res_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_remesh_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal nxi As long, _
'      ByVal x_rptr As Long, _
'      ByVal xi_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_remesh_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As Long, _
'      ByVal ucp_rptr As Long, _
'      ByVal ucpx_rptr As Long, _
'      ByVal ucpt_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_keller_ode_remesh_monitf( _
'      ByVal t As double, _
'      ByVal npts As long, _
'      ByVal npde As long, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal fmon_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_keller_ode_remesh Lib "CLW3226DE_nag.dll" Alias "d03prc" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As Long, _
    ByVal bndary As Long, _
    ByVal uvinit As Long, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal nleft As long, ByVal ncode As long, ByVal odedef As Long, _
    ByVal nxi As long, ByRef xi As double, ByVal neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByVal remesh As Nag_Boolean, ByVal nxfix As long, ByRef xfix As double, _
    ByVal nrmesh As long, ByVal dxmesh As double, ByVal trmesh As double, _
    ByVal ipminf As long, ByVal xratio As double, ByVal con As double, _
    ByVal monitf As Long, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_remesh_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As Long, _
'      ByVal ux_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal p_rptr As Long, _
'      ByVal c_rptr As Long, _
'      ByVal d_rptr As Long, _
'      ByVal s_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_remesh_numflx( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal uleft_rptr As Long, _
'      ByVal uright_rptr As Long, _
'      ByVal flux_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef saved As Nag_D03_Save _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_remesh_bndary( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal t As double, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal ibnd As long, _
'      ByVal g_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_remesh_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal nxi As long, _
'      ByVal x_rptr As Long, _
'      ByVal xi_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_remesh_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As Long, _
'      ByVal vdot_rptr As Long, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As Long, _
'      ByVal ucp_rptr As Long, _
'      ByVal ucpx_rptr As Long, _
'      ByVal ucpt_rptr As Long, _
'      ByVal r_rptr As Long, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_pde_parab_1d_cd_ode_remesh_monitf( _
'      ByVal t As double, _
'      ByVal npts As long, _
'      ByVal npde As long, _
'      ByVal x_rptr As Long, _
'      ByVal u_rptr As Long, _
'      ByVal fmon_rptr As Long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_pde_parab_1d_cd_ode_remesh Lib "CLW3226DE_nag.dll" Alias "d03psc" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As Long, _
    ByVal numflx As Long, _
    ByVal bndary As Long, _
    ByVal uvinit As Long, ByRef u As double, ByVal npts As long, _
    ByRef x As double, ByVal ncode As long, ByVal odedef As Long, _
    ByVal nxi As long, ByRef xi As double, ByVal neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByVal remesh As Nag_Boolean, ByVal nxfix As long, ByRef xfix As double, _
    ByVal nrmesh As long, ByVal dxmesh As double, ByVal trmesh As double, _
    ByVal ipminf As long, ByVal xratio As double, ByVal con As double, _
    ByVal monitf As Long, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pde_parab_1d_euler_roe Lib "CLW3226DE_nag.dll" Alias "d03puc" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pde_parab_1d_euler_osher Lib "CLW3226DE_nag.dll" Alias "d03pvc" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByVal path As Nag_OsherVersion, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pde_parab_1d_euler_hll Lib "CLW3226DE_nag.dll" Alias "d03pwc" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pde_parab_1d_euler_exact Lib "CLW3226DE_nag.dll" Alias "d03pxc" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByVal tol As double, _
    ByVal niter As long, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pde_interp_1d_coll Lib "CLW3226DE_nag.dll" Alias "d03pyc" ( _
    ByVal npde As long, _
    ByRef u As double, _
    ByVal nbkpts As long, _
    ByRef xbkpts As double, _
    ByVal npoly As long, _
    ByVal npts As long, _
    ByRef xp As double, _
    ByVal intpts As long, _
    ByVal itype As long, _
    ByRef up As double, _
    ByRef rsave As double, _
    ByVal lrsave As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pde_interp_1d_fd Lib "CLW3226DE_nag.dll" Alias "d03pzc" ( _
    ByVal npde As long, _
    ByVal m As long, _
    ByRef u As double, _
    ByVal npts As long, _
    ByRef x As double, _
    ByRef xp As double, _
    ByVal intpts As long, _
    ByVal itype As long, _
    ByRef up As double, _
    ByRef fail As NagError _
   )


' chapter d04
' skeleton code for callback function
'  Function nag_numdiff_1d_real_fun( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_numdiff_1d_real Lib "CLW3226DE_nag.dll" Alias "d04aac" ( _
    ByVal xval As double, _
    ByVal nder As long, _
    ByVal hbase As double, _
    ByRef der As double, _
    ByRef erest As double, _
    ByVal fun As Long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_numdiff_1d_real_eval Lib "CLW3226DE_nag.dll" Alias "d04bac" ( _
    ByRef xval As double, _
    ByRef fval As double, _
    ByRef der As double, _
    ByRef erest As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_numdiff_1d_real_absci Lib "CLW3226DE_nag.dll" Alias "d04bbc" ( _
    ByVal x_0 As double, _
    ByVal hbase As double, _
    ByRef xval As double _
   )


' chapter d05
' skeleton code for callback function
'  Function nag_inteq_fredholm2_split_k1( _
'      ByVal x As double, _
'      ByVal s As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_fredholm2_split_k2( _
'      ByVal x As double, _
'      ByVal s As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_fredholm2_split_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_inteq_fredholm2_split Lib "CLW3226DE_nag.dll" Alias "d05aac" ( _
    ByVal lambda As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByVal k1 As Long, _
    ByVal k2 As Long, _
    ByVal g As Long, _
    ByVal kform As Nag_KernelForm, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_inteq_fredholm2_smooth_k( _
'      ByVal x As double, _
'      ByVal s As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_fredholm2_smooth_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_inteq_fredholm2_smooth Lib "CLW3226DE_nag.dll" Alias "d05abc" ( _
    ByVal lambda As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByVal k As Long, _
    ByVal g As Long, _
    ByVal odorev As Nag_Boolean, _
    ByVal ev As Nag_Boolean, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_inteq_volterra2_ck( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_volterra2_cg( _
'      ByVal s As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_volterra2_cf( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_inteq_volterra2 Lib "CLW3226DE_nag.dll" Alias "d05bac" ( _
    ByVal ck As Long, _
    ByVal cg As Long, _
    ByVal cf As Long, _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As long, _
    ByVal alim As double, _
    ByVal tlim As double, _
    ByVal tol As double, _
    ByVal nmesh As long, _
    ByVal thresh As double, _
    ByRef work As double, _
    ByVal lwk As long, _
    ByRef yn As double, _
    ByRef errest As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_inteq_abel2_weak_ck( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_abel2_weak_cf( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_abel2_weak_cg( _
'      ByVal s As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_inteq_abel2_weak Lib "CLW3226DE_nag.dll" Alias "d05bdc" ( _
    ByVal ck As Long, _
    ByVal cf As Long, _
    ByVal cg As Long, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As long, _
    ByVal tlim As double, _
    ByVal tolnl As double, _
    ByVal nmesh As long, _
    ByRef yn As double, _
    ByRef rwsav As double, _
    ByVal lrwsav As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_inteq_abel1_weak_ck( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_abel1_weak_cf( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_inteq_abel1_weak_cg( _
'      ByVal s As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_inteq_abel1_weak Lib "CLW3226DE_nag.dll" Alias "d05bec" ( _
    ByVal ck As Long, _
    ByVal cf As Long, _
    ByVal cg As Long, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As long, _
    ByVal tlim As double, _
    ByVal tolnl As double, _
    ByVal nmesh As long, _
    ByRef yn As double, _
    ByRef rwsav As double, _
    ByVal lrwsav As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_inteq_volterra_weights Lib "CLW3226DE_nag.dll" Alias "d05bwc" ( _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As long, _
    ByVal nomg As long, _
    ByRef omega As double, _
    ByRef sw As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_inteq_abel_weak_weights Lib "CLW3226DE_nag.dll" Alias "d05byc" ( _
    ByVal iorder As long, _
    ByVal iq As long, _
    ByRef omega As double, _
    ByRef sw As double, _
    ByRef fail As NagError _
   )


' chapter d06
   Declare Sub nag_mesh2d_inc Lib "CLW3226DE_nag.dll" Alias "d06aac" ( _
    ByVal nvb As long, _
    ByVal nvmax As long, _
    ByVal nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef bspace As double, _
    ByVal smooth As Nag_Boolean, _
    ByVal coef As double, _
    ByVal power As double, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mesh2d_delaunay Lib "CLW3226DE_nag.dll" Alias "d06abc" ( _
    ByVal nvb As long, _
    ByVal nvint As long, _
    ByVal nvmax As long, _
    ByVal nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef weight As double, _
    ByVal npropa As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mesh2d_front Lib "CLW3226DE_nag.dll" Alias "d06acc" ( _
    ByVal nvb As long, _
    ByVal nvint As long, _
    ByVal nvmax As long, _
    ByVal nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef weight As double, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_mesh2d_bound_fbnd( _
'      ByVal i As long, _
'      ByVal x As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_mesh2d_bound Lib "CLW3226DE_nag.dll" Alias "d06bac" ( _
    ByVal nlines As long, ByRef coorch As double, ByRef lined As long, _
    ByVal fbnd As Long, ByRef crus As double, ByVal sdcrus As long, _
    ByRef rate As double, ByVal ncomp As long, ByRef nlcomp As long, _
    ByRef lcomp As long, ByVal nvmax As long, ByVal nedmx As long, _
    ByRef nvb As long, ByRef coor As double, ByRef nedge As long, _
    ByRef edge As long, ByVal itrace As long, ByVal outfile As String, ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

   Declare Sub nag_mesh2d_smooth Lib "CLW3226DE_nag.dll" Alias "d06cac" ( _
    ByVal nv As long, _
    ByVal nelt As long, _
    ByVal nedge As long, _
    ByRef coor As double, _
    ByRef edge As long, _
    ByRef conn As long, _
    ByVal nvfix As long, _
    ByRef numfix As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByVal nqint As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mesh2d_sparse Lib "CLW3226DE_nag.dll" Alias "d06cbc" ( _
    ByVal nv As long, _
    ByVal nelt As long, _
    ByVal nnzmax As long, _
    ByRef conn As long, _
    ByRef nnz As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mesh2d_renum Lib "CLW3226DE_nag.dll" Alias "d06ccc" ( _
    ByVal nv As long, _
    ByVal nelt As long, _
    ByVal nedge As long, _
    ByVal nnzmax As long, _
    ByRef nnz As long, _
    ByRef coor As double, _
    ByRef edge As long, _
    ByRef conn As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mesh2d_trans Lib "CLW3226DE_nag.dll" Alias "d06dac" ( _
    ByVal mode As long, _
    ByVal nv As long, _
    ByVal nedge As long, _
    ByVal nelt As long, _
    ByVal ntrans As long, _
    ByRef itype As long, _
    ByRef trans As double, _
    ByRef coori As double, _
    ByRef edgei As long, _
    ByRef conni As long, _
    ByRef cooro As double, _
    ByRef edgeo As long, _
    ByRef conno As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mesh2d_join Lib "CLW3226DE_nag.dll" Alias "d06dbc" ( _
    ByVal eps As double, ByVal nv1 As long, ByVal nelt1 As long, _
    ByVal nedge1 As long, ByRef coor1 As double, ByRef edge1 As long, _
    ByRef conn1 As long, ByRef reft1 As long, ByVal nv2 As long, _
    ByVal nelt2 As long, ByVal nedge2 As long, ByRef coor2 As double, _
    ByRef edge2 As long, ByRef conn2 As long, ByRef reft2 As long, _
    ByRef nv3 As long, ByRef nelt3 As long, ByRef nedge3 As long, _
    ByRef coor3 As double, ByRef edge3 As long, ByRef conn3 As long, _
    ByRef reft3 As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef fail As NagError _
   )

